package com.xxfc.rv;

import android.text.TextUtils;

import com.xxfc.rv.db.table.ChatMessage;

public class ChatHolderFactory {

    public static int getChatHolderType(String mLoginUserId, ChatMessage message) {
        ChatHolderTypeEnum type = null;
        if (message != null && !TextUtils.isEmpty(mLoginUserId)) {
            switch (message.getMessageType()) {
                case 1: //文本文件
                    if (mLoginUserId.equals(message.getFromUserId())) {
                        type = ChatHolderTypeEnum.VIEW_TO_TEXT;
                    } else {
                        type = ChatHolderTypeEnum.VIEW_FROM_TEXT;
                    }
                    break;
                case 2: // 文件
                    if (mLoginUserId.equals(message.getFromUserId())) {
                        type = ChatHolderTypeEnum.VIEW_TO_FILE;
                    } else {
                        type = ChatHolderTypeEnum.VIEW_FROM_FILE;
                    }
                    break;
                case 3: //图片
                    if (mLoginUserId.equals(message.getFromUserId())) {
                        type = ChatHolderTypeEnum.VIEW_TO_IMAGE;
                    } else {
                        type = ChatHolderTypeEnum.VIEW_FROM_IMAGE;
                    }
                    break;
                case 4:  // 语音
                    if (mLoginUserId.equals(message.getFromUserId())) {
                        type = ChatHolderTypeEnum.VIEW_TO_VOICE;
                    } else {
                        type = ChatHolderTypeEnum.VIEW_FROM_VOICE;
                    }
                    break;
                case 5: // 语音通话
                    if (mLoginUserId.equals(message.getFromUserId())) {
                        type = ChatHolderTypeEnum.VIEW_TO_VOLTE;
                    } else {
                        type = ChatHolderTypeEnum.VIEW_FROM_VOLTE;
                    }
                    break;
                case 6: //视频通话
                    if (mLoginUserId.equals(message.getFromUserId())) {
                        type = ChatHolderTypeEnum.VIEW_TO_VIDEO;
                    } else {
                        type = ChatHolderTypeEnum.VIEW_FROM_VIDEO;
                    }
                    break;
            }
        }
        if (type != null)
            return type.getId();
        return 0;
    }

}
