package com.xxfc.rv.db.table;

import com.google.gson.Gson;
import com.j256.ormlite.field.DataType;
import com.j256.ormlite.field.DatabaseField;
import com.j256.ormlite.table.DatabaseTable;
import com.xxfc.rv.db.CallTypeEnum;
import com.xxfc.rv.db.MessageTypeEnum;

@DatabaseTable(tableName = "tb_message")
public class ChatMessage {
    @DatabaseField(columnName = "_id", dataType = DataType.INTEGER, generatedId = true)
    private int id;
    @DatabaseField(canBeNull = false)
    private String packId; // 消息包的Id
    @DatabaseField
    private String fromId;
    @DatabaseField
    private String fromUserId;
    @DatabaseField
    private String toUserId;
    @DatabaseField
    private String fromUserName;
    @DatabaseField
    private String toUserName;
    @DatabaseField(canBeNull = false)
    private int messageType; // 消息类型 1 为文本，2为文件，3为图片，4为语音，5为语音通话，6为视频通话
    @DatabaseField
    private int callType; //  当messageType 为5或者6时起效  100：
    @DatabaseField(canBeNull = false)
    private int timeSend; // 发送时间
    @DatabaseField
    private int timeReceive; // 接收到消息回执的时间
    @DatabaseField
    private int timeEnd;   // 结束时间（当为 语音通话/视频通话时）
    @DatabaseField
    private int upLoadStatus; // 上传状态 1 上传中，2 上传成功，3 上传失败，当类型为  2，3，4时
    @DatabaseField
    private int uploadSchedule; // 上传进度，当类型为  2，3，4时
    @DatabaseField
    private boolean isDownload;      //代表是否下载完成
    @DatabaseField
    private String filePath; // 文件路径
    @DatabaseField
    private int sipStatus; //    语音或者视频通话的状态，本地数据库存储即可
    @DatabaseField
    private int messageStatus;  // 消息的发送状态,默认值=0，代表发送中，1 发送成功，2 发送失败
    @DatabaseField
    private String content; // 内容

    @DatabaseField
    private int timeLen; // 语音时长

    @DatabaseField
    private boolean isRead; // 是否已读


    public int getId() {
        return id;
    }

    public void setId(int id) {
        this.id = id;
    }

    public String getFromUserId() {
        return fromUserId;
    }

    public void setFromUserId(String fromUserId) {
        this.fromUserId = fromUserId;
    }

    public String getToUserId() {
        return toUserId;
    }

    public void setToUserId(String toUserId) {
        this.toUserId = toUserId;
    }

    public String getFromUserName() {
        return fromUserName;
    }

    public void setFromUserName(String fromUserName) {
        this.fromUserName = fromUserName;
    }

    public String getToUserName() {
        return toUserName;
    }

    public void setToUserName(String toUserName) {
        this.toUserName = toUserName;
    }

    public int getMessageType() {
        return messageType;
    }

    public void setMessageType(MessageTypeEnum type) {
        this.messageType = type.getType();
    }

    public int getTimeSend() {
        return timeSend;
    }

    public void setTimeSend(int timeSend) {
        this.timeSend = timeSend;
    }

    public int getTimeReceive() {
        return timeReceive;
    }

    public void setTimeReceive(int timeReceive) {
        this.timeReceive = timeReceive;
    }

    public int getTimeEnd() {
        return timeEnd;
    }

    public void setTimeEnd(int timeEnd) {
        this.timeEnd = timeEnd;
    }

    public boolean isDownload() {
        return isDownload;
    }

    public void setDownload(boolean download) {
        isDownload = download;
    }

    public void setMessageType(int messageType) {
        this.messageType = messageType;
    }

    public int getUpLoadStatus() {
        return upLoadStatus;
    }

    public void setUpLoadStatus(int upLoadStatus) {
        this.upLoadStatus = upLoadStatus;
    }

    public int getUploadSchedule() {
        return uploadSchedule;
    }

    public void setUploadSchedule(int uploadSchedule) {
        this.uploadSchedule = uploadSchedule;
    }

    public boolean getIsDownload() {
        return isDownload;
    }

    public void setIsDownload(boolean isDownload) {
        this.isDownload = isDownload;
    }

    public int getSipStatus() {
        return sipStatus;
    }

    public void setSipStatus(int sipStatus) {
        this.sipStatus = sipStatus;
    }

    public int getMessageStatus() {
        return messageStatus;
    }

    public int getCallType() {
        return callType;
    }

    public void setCallType(int callType) {
        this.callType = callType;
    }

    public void setCallType(CallTypeEnum callTypeEnum) {
        this.callType = callTypeEnum.getType();
    }

    public void setMessageStatus(int messageStatus) {
        this.messageStatus = messageStatus;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getPackId() {
        return packId;
    }

    public void setPackId(String packId) {
        this.packId = packId;
    }

    public String getFilePath() {
        return filePath;
    }

    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }

    public String getFromId() {
        return fromId;
    }

    public void setFromId(String fromId) {
        this.fromId = fromId;
    }

    public int getTimeLen() {
        return timeLen;
    }

    public void setTimeLen(int timeLen) {
        this.timeLen = timeLen;
    }

    public boolean isRead() {
        return isRead;
    }

    public void setRead(boolean read) {
        isRead = read;
    }

    public static ChatMessage json2Message(String json) {
        return new Gson().fromJson(json, ChatMessage.class);
    }

    @Override
    public String toString() {
        return new Gson().toJson(this);
    }

    public String toJsonString() {
        return new Gson().toJson(this);
    }

}
