package com.xxfc.rv.service;

import android.content.Context;

import com.xxfc.rv.db.dao.MessageDao;
import com.xxfc.rv.db.table.ChatMessage;

import java.util.List;

public class ChatMessageServiceImp implements IChatMessageService {

    private MessageDao dao = null;
    private static ChatMessageServiceImp instance = null;

    private ChatMessageServiceImp(Context context) {
        dao = MessageDao.getInstance(context);
    }

    public static ChatMessageServiceImp getInstance(Context context) {
        if (instance == null) {
            instance = new ChatMessageServiceImp(context);
        }
        return instance;
    }


    @Override
    public List<ChatMessage> getAllMessage(String userId) {
        return dao.getAllChatMessageByConversation(userId);
    }

    @Override
    public void addMessage(ChatMessage message) {
        dao.addMessage(message);
    }

    @Override
    public void setMsgSendSuccess(String receiptId) {
        dao.setMsgSuccess(receiptId);
    }

    @Override
    public void setUpProgress(String packId, int progress) {
        dao.setUpProgress(packId, progress);
    }

    @Override
    public void setUpFailure(String packId) {
        dao.setUpFailure(packId);
    }
}
