package com.xxfc.rv.xmpp;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.os.Vibrator;
import android.text.TextUtils;
import android.util.Log;

import com.xxfc.rv.ImService;
import com.xxfc.rv.call.JitsistateMachine;
import com.xxfc.rv.call.MessageEventSipEVent;
import com.xxfc.rv.db.CallTypeEnum;
import com.xxfc.rv.db.MessageTypeEnum;
import com.xxfc.rv.db.table.ChatMessage;

import org.jivesoftware.smack.chat2.Chat;
import org.jivesoftware.smack.chat2.IncomingChatMessageListener;
import org.jivesoftware.smack.packet.Message;
import org.json.JSONException;
import org.jxmpp.jid.EntityBareJid;
import org.jxmpp.util.XmppStringUtils;

import java.util.HashMap;
import java.util.Map;
import java.util.UUID;
import java.util.concurrent.TimeUnit;

import de.greenrobot.event.EventBus;

import static android.content.Context.VIBRATOR_SERVICE;

/**
 * Created by Administrator on 2017/11/24.
 */

public class XChatMessageListener implements IncomingChatMessageListener {
    private ImService mService;

    private String mLoginUserId;
    private Map<String, String> mMsgIDMap = new HashMap<>();// 因为多点登录 转发 问题，先用一个简单的方法去重

    public XChatMessageListener(ImService service) {
        mService = service;
        mLoginUserId = mService.getUserId();
        mMsgIDMap = new HashMap<>();
    }

    private Context getContext() {
        return mService;
    }

    @Override
    public void newIncomingMessage(EntityBareJid fromxx, Message message, Chat chat) {
//        // body外
//        String from = XmppStringUtils.parseBareJid(message.getFrom().toString());
//        String resource = message.getFrom().toString().substring(message.getFrom().toString().indexOf("/") + 1, message.getFrom().length());// 发送方的resource ex:ios 、pc...
        String packetID = message.getPacketID();
//        // body内(即我们发送的ChatMessage)
        String body = message.getBody();
        ChatMessage chatMessage = ChatMessage.json2Message(body);
//        String fromUserId = chatMessage.getFromUserId();
//        String toUserId = chatMessage.getToUserId();

        if (TextUtils.isEmpty(chatMessage.getPackId())) {
            chatMessage.setPackId(packetID);
        }
//        chatMessage.setFromUserId(message.getFrom().toString());
//        chatMessage.setToUserId(message.getTo().toString());
        int type = chatMessage.getMessageType();
        if (type == 0) { // 消息过滤
            return;
        }

        if (type == MessageTypeEnum.TEXT.getType()) {  // 收到文本
            mService.notificationMessage(chatMessage);
        } else if (type == MessageTypeEnum.PIC.getType()) { // 收到图片
            mService.notificationMessage(chatMessage);
        } else if (type == MessageTypeEnum.FILE.getType()) {  // 收到文件
            mService.notificationMessage(chatMessage);
        } else if (type == MessageTypeEnum.VOICE.getType()) {  // 收到录音文件
            mService.notificationMessage(chatMessage);
        } else if (type == MessageTypeEnum.VOLTE_CALL.getType()) { // 发送语音通话
            dealVolteCall(chatMessage);
        } else if (type == MessageTypeEnum.VIDEO_CALL.getType()) { // 发送视频通话
            dealVideoCall(chatMessage);
        }
    }

    /**********
     * 处理视频通话
     * @param chatMessage
     */
    private void dealVideoCall(ChatMessage chatMessage) {
        int callType = chatMessage.getCallType();
        if (callType == CallTypeEnum.CONNECT_VIDEO.getType()) {

        } else if (callType == CallTypeEnum.CONNECTED_VIDEO.getType()) {

        } else if (callType == CallTypeEnum.NO_CONNECT_VIDEO.getType()) {

        } else if (callType == CallTypeEnum.END_CONNECT_VIDEO.getType()) {

        }
    }

    /**********
     * 处理语音通话
     * @param chatMessage
     */
    private void dealVolteCall(ChatMessage chatMessage) {
        int callType = chatMessage.getCallType();
        if (callType == CallTypeEnum.CONNECT_VOICE.getType()) {
            if (JitsistateMachine.isInCalling) {  // 对方来电 ，本人 正在通话
                // 发送忙线通知
            }
            if ((int) System.currentTimeMillis() / 1000 - chatMessage.getTimeSend() <= 30) {
                // 跳转到语音待接受界面
                EventBus.getDefault().post(new MessageEventSipEVent(100, chatMessage.getFromUserId(), chatMessage));
            }
        } else if (callType == CallTypeEnum.CONNECTED_VOICE.getType()) {

        } else if (callType == CallTypeEnum.NO_CONNECT_VOICE.getType()) {

        } else if (callType == CallTypeEnum.END_CONNECT_VOICE.getType()) {

        }
    }
}
